# HG changeset patch
# User Scott Mitchell <scott_mitchell@apple.com>
# Date 1651280176 25200
#      Fri Apr 29 17:56:16 2022 -0700
# Node ID ac2a48aa4efb86cd34189dd1b62fe24c5afbab70
# Parent  a736a7a613ea6e182ff86fbadcb98bb0f8891c0b
H2: RST_STREAM(CANCEL) on timeout instead of PROTOCOL_ERROR

When a timeout occurs this condition maybe temporary and retryable. For example if the network
bandwidth is temporarily throttled. If a PROTOCOL_ERROR is returned the client is unlikely to
retry due to unknown error conditions. Returning CANCEL provides more context as an application
level error that the client is more likely to retry.

diff -r a736a7a613ea -r ac2a48aa4efb src/http/v2/ngx_http_v2.c
--- a/src/http/v2/ngx_http_v2.c	Tue Feb 08 17:35:27 2022 +0300
+++ b/src/http/v2/ngx_http_v2.c	Fri Apr 29 17:56:16 2022 -0700
@@ -4636,7 +4636,7 @@
 
         if (!stream->out_closed) {
             if (ngx_http_v2_send_rst_stream(h2c, node->id,
-                                      fc->timedout ? NGX_HTTP_V2_PROTOCOL_ERROR
+                                      fc->timedout ? NGX_HTTP_V2_CANCEL
                                                    : NGX_HTTP_V2_INTERNAL_ERROR)
                 != NGX_OK)
             {
